import { PlottableModel, Transform } from './4d-objects';
import { MapHelper } from './4d-helper';
import { Observable } from 'rxjs';
import { PlottableReference } from './renderer';
/**
 * <p>Helper class for <a href="https://leafletjs.com/">Leaflet</a>. Contains methods to zoom to a location and add/remove a model to the map.</p>
 * <p>You can play with a(n) (<a href="https://stackblitz.com/edit/angular-demo-leaflet">angular</a> or <a href="https://stackblitz.com/edit/react-demo-leaflet">react</a>) demo on stackblitz.</p>
 */
export declare class LeafletHelper extends MapHelper {
    private L;
    private _objectCache;
    map: any;
    constructor(map: any, L: any);
    getAuthenticatedUrl(p: PlottableModel<any>, file: string, tier?: number): Promise<string[]>;
    setPlottable(p: PlottableModel<any>, args?: any): Observable<PlottableReference>;
    clearPlottables(): void;
    sendCameraTo(p: PlottableModel<any>, duration?: number, args?: any): Observable<any>;
    getMapObjectFor(p: PlottableModel<any>): any;
    changeOpacity(t: Transform, opacity?: number): void;
    resolveItem(movement: any): PlottableModel<any>;
    /**
     * <p>Generate unique string key for [[PlottableModel]].</p>
     * @param p Uses the [[PlottableModel]]'s classname and id to generate key
     */
    private keyFor;
}
