import { Observable } from "rxjs";
import { Annotation, PlottableModel, Transform } from "..";
/**
 * A reference to the object type unquie to the MapHelper implementation that represents a single plottable
 */
export interface PlottableReference {
    plottable: PlottableModel<any>;
    object: any;
    boundingSphere?: any;
    position?: any;
}
/**
 * A renderer can be registered to a #MapHelper to determine how a plottable object is to be applied
 */
export declare class Renderer<T extends Annotation | Transform> {
    _debug_1: string;
    _debug_2: string;
    _log(id?: string, data?: any): void;
    onAdd(obj: T, args?: any): Observable<PlottableReference>;
    onUpdate(obj: T, pr: PlottableReference, args?: any): Observable<PlottableReference>;
    onRemove(obj: T, pr: PlottableReference): void;
    destory(): void;
    monitorEvent(id: string, event: any): void;
}
