
const path = require('path');

module.exports = {
  entry: './index.ts',
  module: {
    rules: [
      {
        test: /\.tsx?$/,
        use: 'ts-loader',
        exclude: /node_modules/
      },
      {
        test: require.resolve("vasat"),
        loader: "expose-loader",
        options: {
          exposes: ["Vasat"]
        }
      }
    ],
  },
  externals: {
    rxjs: 'rxjs'
  },
  resolve: {
    extensions: ['.tsx', '.ts', '.js']
  },
  optimization: {
    minimize: false
  },
  output: {
    path: path.resolve(__dirname, 'dist'),
    globalObject: 'this',
    filename: 'fourd.js',
    library: {
      type: "umd",
      umdNamedDefine: true
    }
  }
};